#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include "service.h"
#include "logfile.h"

SERVICE_STATUS           _ssStatus;// T[rX
SERVICE_STATUS_HANDLE    _sshStatusHandle = 0;

HANDLE    _hEventShutDown = NULL;// ICxgnh

CLogFile    *lpLog = NULL;// Oo
void ServiceInstall(LPCTSTR lpctszServiceName,
LPCTSTR lpctszDisplyName, LPCTSTR lpcszDependencies)
{
    SC_HANDLE    schService   = NULL;
    SC_HANDLE    schSCManager = NULL;
    TCHAR        szPath[MAXPATHSIZE];

    __try{
        /* W[̃t@C𓾂 */
        if(GetModuleFileName(NULL, szPath, MAXPATHSIZE) == 0){
            printf("%s ̓CXg[ł܂łB - %ld\n",
                    lpctszDisplyName, GetLastError());
            __leave;
        }

        /* T[rX}l[Wւ̐ڑm */
        schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
        if(schSCManager == NULL){
            printf("OpenSCManager failed. code=%d\n", GetLastError());
            __leave;
        }

        /* T[rXf[^x[Xɓo^ */
        schService = CreateService(schSCManager, lpctszServiceName,
                lpctszDisplyName, SERVICE_ALL_ACCESS,
                SERVICE_WIN32_OWN_PROCESS, SERVICE_DEMAND_START,
                SERVICE_ERROR_NORMAL, szPath, NULL, NULL, lpcszDependencies,
                NULL, NULL);
        if(schService == NULL){
            printf("CreateService failed. code=%d\n", GetLastError());
            __leave;
        }

        printf("%s CXg[܂B\n", lpctszDisplyName);
    }
    __finally{
        if(schService){
            CloseServiceHandle(schService);
        }
        if(schSCManager){
            CloseServiceHandle(schSCManager);
        }
    }
}
void ServiceStart(LPCTSTR lpctszServiceName, LPCTSTR lpctszDisplyName)
{
    SC_HANDLE    schSCManager = NULL;
    SC_HANDLE    schService   = NULL;

    __try{
        /* T[rX}l[Wւ̐ڑm */
        schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
        if(schSCManager == NULL){
            printf("OpenSCManager failed. code=%d\n", GetLastError());
            __leave;
        }

        /* T[rXI[v */
        schService = OpenService(
                schSCManager, lpctszServiceName, SERVICE_ALL_ACCESS);
        if(schService == NULL){
            printf("OpenService failed. code=%d\n", GetLastError());
            __leave;
        }

        /* T[rXJn */
        if(StartService(schService, 0, NULL)){
            Sleep(MAXSTOPINT);
            while(QueryServiceStatus(schService, &_ssStatus)){
                if(_ssStatus.dwCurrentState != SERVICE_START_PENDING){
                    break;
                }
                Sleep(MAXSTOPINT);
            }
            if(_ssStatus.dwCurrentState == SERVICE_RUNNING){
                printf("\n%s Jn܂\n", lpctszDisplyName);
            }
            else{
                printf("\n%s ̊JnɎs܂\n", lpctszDisplyName);
            }
        }
    }
    __finally{
        if(schService){
            CloseServiceHandle(schService);
        }
        if(schSCManager){
            CloseServiceHandle(schSCManager);
        }
    }
}
void main(int argc, char *argv[])
{
    SERVICE_TABLE_ENTRY dispatchTable[] = {
        { SZSERVICENAME, (LPSERVICE_MAIN_FUNCTION)ServiceMain },
        { NULL, NULL }
    };
    ZeroMemory(&_ssStatus, sizeof(_ssStatus));

    /* R}hC̃`FbN */
    if((argc > 1) && (*argv[1] == '-')){
        if(_stricmp("install", argv[1]+1) == 0){
            /* CXg[ */
            ServiceInstall(SZSERVICENAME,
                    SZSERVICEDISPLAYNAME, SZDEPENDENCIES);
            return;
        }
        else if(_stricmp("uninstall", argv[1]+1) == 0){
            /* ACXg[ */
            ServiceStop(SZSERVICENAME, SZSERVICEDISPLAYNAME);
            ServiceUnInstall(SZSERVICENAME, SZSERVICEDISPLAYNAME);
            return;
        }
        else if(_stricmp("start", argv[1]+1) == 0){
            /* T[rXJn */
            ServiceStart(SZSERVICENAME, SZSERVICEDISPLAYNAME);
            return;
        }
        else if(_stricmp("stop", argv[1]+1) == 0){
            /* T[rX~ */
            ServiceStop(SZSERVICENAME, SZSERVICEDISPLAYNAME);
            return;
        }
    }

    /* Oo͊Jn */
    lpLog = new CLogFile();
    lpLog->StartLog(TEXT("C:\\ServiceSampleLog.txt"));

    /* T[rX}l[Wɐڑ */
    _ssStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
    if(StartServiceCtrlDispatcher(dispatchTable) == FALSE){
        printf("StartServiceCtrlDispatcher failed. code=%d\n", GetLastError());
    }
}
void ServiceMain(DWORD dwArgc, LPTSTR *lpszArgv)
{
    LRESULT lResult = ERROR_SUCCESS;

    __try{
        /* T[rXv󂯕t֐o^ */
        _sshStatusHandle = RegisterServiceCtrlHandler(
                SZSERVICENAME, (LPHANDLER_FUNCTION)ServiceCtrl);
        if(_sshStatusHandle == 0){
            lResult = GetLastError();
            __leave;
        }

        /* T[rX̊Jnʒm */
        lResult = ServiceReportSCManager(
                SERVICE_START_PENDING, NO_ERROR, MAXHINT);
        if(lResult != ERROR_SUCCESS){
            __leave;
        }

        /* T[rX~Cxg̐ */
        if((_hEventShutDown = CreateEvent(NULL, TRUE, FALSE, NULL)) == NULL){
            lResult = GetLastError();
            __leave;
        }

        /* T[rX */
        lResult = ServiceExec(dwArgc, lpszArgv);
    }
    __finally{
        _ssStatus.dwWin32ExitCode = (DWORD)lResult;

        /* I */
        if(_hEventShutDown != NULL){
            CloseHandle(_hEventShutDown);
        }
        if(_sshStatusHandle != 0){
            /* T[rX̒~ʒm */
            ServiceReportSCManager(SERVICE_STOPPED, 0, 0);
        }
    }
}
LRESULT ServiceReportSCManager(
DWORD dwCurrentState, DWORD dwWin32ExitCode, DWORD dwWaitHint)
{
    static DWORD    dwCheckPoint = 1;
    LRESULT         lResult = ERROR_SUCCESS;

    _ssStatus.dwControlsAccepted = 0;
    if(dwCurrentState != SERVICE_START_PENDING){
        _ssStatus.dwControlsAccepted = SERVICE_ACCEPT_STOP;
    }

    _ssStatus.dwCurrentState  = dwCurrentState;
    _ssStatus.dwWin32ExitCode = dwWin32ExitCode;
    _ssStatus.dwWaitHint      = dwWaitHint;
    _ssStatus.dwCheckPoint    = dwCheckPoint++;

    if((dwCurrentState == SERVICE_RUNNING)
     ||(dwCurrentState == SERVICE_STOPPED)){
        _ssStatus.dwCheckPoint = 0;// `FbN|Cg̏
    }

    if(SetServiceStatus(_sshStatusHandle, &_ssStatus) == FALSE){//T[rX̏ԂT[rX}l[Wɒʒm
        lResult = GetLastError();
    }

    return lResult;
}
LRESULT ServiceExec(DWORD dwArgc, LPTSTR *lplpszArgv)
{
    LRESULT lResult = ERROR_SUCCESS;

    lResult = ServiceReportSCManager(SERVICE_RUNNING, NO_ERROR, 0);// T[rXsꂽƂʒm
    if(lResult != ERROR_SUCCESS){
        return lResult;
    }

    while(WaitForSingleObject(_hEventShutDown, 10000) != WAIT_OBJECT_0){
        lpLog->PrintLog(TEXT("s"));// T[rX̏
    }

    return lResult;
}
void ServiceCtrl(DWORD dwCtrlCode)
{
    DWORD  dwState = SERVICE_RUNNING;

    switch(dwCtrlCode){
        case SERVICE_CONTROL_STOP:
            ServiceReportSCManager(SERVICE_STOP_PENDING, NO_ERROR, 0);// T[rX~JnƂʒmĂI
            SetEvent(_hEventShutDown);
            return;
        case SERVICE_CONTROL_INTERROGATE:
            break;
    }

    ServiceReportSCManager(dwState, NO_ERROR, 0);
}
void ServiceStop(LPCTSTR lpctszServiceName, LPCTSTR lpctszDisplyName)
{
    SC_HANDLE    schSCManager = NULL;
    SC_HANDLE    schService   = NULL;

    __try{
        schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);// T[rX}l[Wւ̐ڑm
        if(schSCManager == NULL){
            printf("OpenSCManager failed. code=%d\n", GetLastError());
            __leave;
        }

        schService = OpenService(// T[rXI[v
                schSCManager, lpctszServiceName, SERVICE_ALL_ACCESS);
        if(schService == NULL){
            printf("OpenService failed. code=%d\n", GetLastError());
            __leave;
        }

        if(ControlService(schService, SERVICE_CONTROL_STOP, &_ssStatus)){// T[rX~
            Sleep(MAXSTOPINT);
            while(QueryServiceStatus(schService, &_ssStatus)){
                if(_ssStatus.dwCurrentState != SERVICE_STOP_PENDING){
                    break;
                }
                Sleep(MAXSTOPINT);
            }
            if(_ssStatus.dwCurrentState == SERVICE_STOPPED){
                printf("\n%s ~܂\n", lpctszDisplyName);
            }
            else{
                printf("\n%s ̒~Ɏs܂\n", lpctszDisplyName);
            }
        }
    }
    __finally{
        if(schService){
            CloseServiceHandle(schService);
        }
        if(schSCManager){
            CloseServiceHandle(schSCManager);
        }
    }
}
void ServiceUnInstall(LPCTSTR lpctszServiceName, LPCTSTR lpctszDisplyName)
{
    SC_HANDLE    schSCManager = NULL;
    SC_HANDLE    schService   = NULL;

    __try{
        schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);// T[rX}l[Wւ̐ڑm
        if(schSCManager == NULL){
            printf("OpenSCManager failed. code=%d\n", GetLastError());
            __leave;
        }

        schService = OpenService(// T[rXI[v
                schSCManager, lpctszServiceName, SERVICE_ALL_ACCESS);
        if(schService == NULL){
            printf("OpenService failed. code=%d\n", GetLastError());
            __leave;
        }

        if(DeleteService(schService)){// T[rXf[^x[X폜
            printf("%s ACXg[܂\n", lpctszDisplyName);
        }
    }
    __finally{
        if(schService){
            CloseServiceHandle(schService);
        }
    }
}
