#include <windows.h>
#include <shlobj.h>
#include <stdio.h>
HRESULT CreateShortCut(LPCSTR lpcszLinkFile,
LPCSTR lpcszShortCutFile, LPCSTR lpcszArg, LPCTSTR lpcszWorkDir)
{
    IShellLink      *lpshlink  = NULL;
    IPersistFile    *lpperfile = NULL;
    WCHAR           wszLink[MAX_PATH];
    HRESULT         hResult;

    hResult = CoCreateInstance(CLSID_ShellLink,
            NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID*)&lpshlink);
    if(FAILED(hResult)){
        return hResult;
    }

    __try{
        if(FAILED((hResult = lpshlink->QueryInterface(IID_IPersistFile, (LPVOID*)&lpperfile)))){
             __leave;
        }

        if(FAILED((hResult = lpshlink->SetPath(lpcszShortCutFile)))){
            __leave;
        }
        if(FAILED((hResult = lpshlink->SetArguments(lpcszArg)))){
            __leave;
        }
        if(FAILED((hResult = lpshlink->SetWorkingDirectory(lpcszWorkDir)))){
            __leave;
        }

        MultiByteToWideChar(CP_ACP, 0, lpcszLinkFile, -1, wszLink, MAX_PATH);
        if(FAILED((hResult = lpperfile->Save(wszLink, TRUE)))){
            __leave;
        }
    }
    __finally{
        if(lpperfile){
            lpperfile->Release();
        }
        if(lpshlink){
            lpshlink->Release();
        }
    }

    return hResult;
}

int main(int argc, char *argv[])
{
    CoInitialize(NULL);

    CHAR szLinkFile[MAX_PATH];
    CHAR szCurrentDir[MAX_PATH];

    LPSTR lpszFile = argv[1];
    GetCurrentDirectory(sizeof(szCurrentDir), szCurrentDir);
    wsprintf(szLinkFile, "%s.lnk", lpszFile);

    HRESULT hResult = CreateShortCut(szLinkFile, lpszFile, "", szCurrentDir);
    if(FAILED(hResult)){
        printf("CreateShortCut code = 0x%X\n", hResult);
    }

    CoUninitialize();
    return 0;
}
